/* -*- Mode: java; tab-width: 8; c-basic-offset: 4 -*-
 * Copyright  1997, 1998 Netscape Communications Corporation, All Rights Reserved.
 */

package com.netscape.javascript.CORBA;

import com.netscape.javascript.*;
import org.omg.CORBA.InterfaceDefPackage.*;
import org.omg.CORBA.DefinitionKind;
import org.omg.CORBA.Contained;
import org.omg.CORBA.ModuleDef;
import org.omg.CORBA.ModuleDefHelper;
import org.omg.CORBA.InterfaceDef;
import org.omg.CORBA.InterfaceDefHelper;
import org.omg.CORBA.StructDef;
import org.omg.CORBA.ExceptionDef;
import org.omg.CORBA.Request;

public class Interface extends ScriptableObject
implements Function
{

    public Scriptable create() { return new Interface(null); }
    public Scriptable construct(Object[] args) {
	return null;
    }
    public String getClassName() { return "Interface"; }
    public Interface(InterfaceDef iface) { this.iface = iface; }

    public Object getDefaultValue(Class hint) {
	if (hint == null ||
	    hint == String.class)
	    return "[CORBA Interface " + iface.absolute_name() + "]";
	return this;
    }

    public boolean has(String id, int index, Scriptable start) {
	return false;
    }

    public void set(String id, int index, Scriptable start) { } ;
    public Object get(String id, int index, Scriptable start) {
	// XXX handle constants in an interface
	return Scriptable.NOT_FOUND;
    }

    public Object call(Scriptable thisObj, Object[] args) {
	
	if (args == null ||
	    args.length < 1)    return Context.getUndefinedValue ();
	
	if (args[0].getClass() == String.class)
        	return new CORBAObject(CORBAObject.orb.bind(iface.describe_interface().id,
						    (String)args[0], null, null));
        else
        if (args[0] instanceof Scriptable)
        {
                String name = null;
                
                if (args.length == 2 && args[1] instanceof String)    
                        name = (String)args[1];
                
                DynamicWrapper dw = new DynamicWrapper ((Scriptable)args[0], iface, name);
                Init.boa.obj_is_ready (dw);
                
                return new CORBAObject (dw);
        }
        return Context.getUndefinedValue ();
    }

    InterfaceDef iface;
}
